//
// automatically generated by spin2cpp v3.5.0 on Sat Feb 25 23:15:46 2017
// spin2cpp --ccode --main /Users/altergator/Downloads/Freq_Counter_Demo - Archive  [Date 2017.02.25  Time 20/Freq_Counter_Demo.spin 
//

/* 
─────────────────────────────────────────────────    
File: Float32.spin
Version: 1.6
Copyright (c) 2009 Parallax, Inc.
See end of file for terms of use.

Author: Cam Thompson                                      
─────────────────────────────────────────────────
 */
/* 
HISTORY:
  This object provides IEEE 754 compliant 32-bit floating point math routines implemented in assembler.
  The following table summarizes the differences between: FloatMath, Float32, and Float32Full.

   ┌──────────────────────────┬────────────┬───────────┬───────────┐
   │                          │ FloatMath  │  Float32  │Float32Full│
   ├──────────────────────────┼────────────┼───────────┼───────────┤
   │ Cogs required:           │     0      │     1     │     2     │
   ├──────────────────────────┼────────────┼───────────┼───────────┤
   │ Execution Speed:         │    Slow    │    Fast   │    Fast   │
   │   e.g. FADD (usec)       │    371     │     39    │     39    │
   ├──────────────────────────┼────────────┼───────────┼───────────┤ 
   │ Methods:                 │            │           │           │
   │   FAdd, FSub, FMul, FDiv │     •      │     •     │     •     │
   │   FFloat, FTrunc, FRound │     •      │     •     │     •     │
   │   FSqr, FNeg, FAbs       │     •      │     •     │     •     │
   ├──────────────────────────┼────────────┼───────────┼───────────┤ 
   │   Sin, Cos, Tan          │            │     •     │     •     │
   │   Radians, Degrees       │            │     •     │     •     │
   │   Log, Log10, Exp, Exp10 │            │     •     │     •     │
   │   Pow, Frac              │            │     •     │     •     │
   │   FMod                   │            │     •     │     •     │
   │   Fmin, Fmax             │            │     •     │     •     │
   ├──────────────────────────┼────────────┼───────────┼───────────┤ 
   │   FMod                   │            │           │     •     │
   │   ASin, ACos, ATan       │            │           │     •     │
   │   ATan2                  │            │           │     •     │
   │   Floor, Ceil            │            │           │     •     │
   │   FFunc                  │            │           │     •     │
   └──────────────────────────┴────────────┴───────────┴───────────┘
  Additional documentation is provided in the file: Propeller Floating Point.pdf

  V1.6 - December 15, 2009
  • fixed problem in Exp function, and base=0 case in Pow  
  V1.5 - July 14, 2009
  • added comments to Spin methods
  • removed sendCmd comments
  • added stop call to release FLOAT32A cog
  V1.4 - September 25, 2007
  • fixed problem in loadTable routine used by Log and Exp functions
  V1.3 - April 1, 2007
  • fixed Sin/Cos interpolation code
  V1.2 - March 26, 2007
  • fixed Pow to handle negative base values
  V1.1 - June 22, 2006
  • updated Sin/Cos code to correct problem with negative values 
  V1.0 - May 17, 2006 
  • original version

USAGE:
  • call start first.
  • Float32 uses one cog for its operation.   
 */
#include <propeller.h>
#include "Float32.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#else
#define INLINE__ static
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static char dat[] = {
  0xf0, 0xb3, 0xbf, 0x0a, 0x00, 0x00, 0x68, 0x5c, 0xd9, 0xb5, 0xbf, 0xa0, 0xda, 0xc5, 0xbf, 0x08, 
  0x04, 0xb4, 0xff, 0x80, 0xda, 0xcd, 0xbf, 0x08, 0x10, 0xb2, 0xff, 0x2a, 0x13, 0xb2, 0x7f, 0x85, 
  0x30, 0x00, 0x6c, 0x5c, 0x01, 0xb2, 0xff, 0x2c, 0x0a, 0xb2, 0xff, 0x80, 0xd9, 0x01, 0x3c, 0x5c, 
  0x41, 0xaa, 0xfc, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x3c, 0xaa, 0xfc, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x59, 0xce, 0xfc, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x6b, 0xf4, 0xfc, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x7b, 0x0e, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x88, 0x30, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x8a, 0x30, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x99, 0x68, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x36, 0x70, 0xfc, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0xcd, 0xf8, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0xcb, 0xf8, 0xfd, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0xfd, 0x08, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x05, 0x11, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x09, 0x19, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x20, 0x85, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x23, 0x85, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0x43, 0xc1, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 0x61, 0xd5, 0xfe, 0x5c, 0x31, 0x00, 0x7c, 0x5c, 
  0xcb, 0xc5, 0xbf, 0xa0, 0xf0, 0xb3, 0xbf, 0xa0, 0x04, 0xb2, 0xff, 0x80, 0xd9, 0xc5, 0x3f, 0x08, 
  0xf0, 0x93, 0x3f, 0x08, 0x00, 0x00, 0x7c, 0x5c, 0xb8, 0x94, 0xfd, 0x5c, 0xe1, 0xc5, 0xbf, 0xa0, 
  0x00, 0x00, 0x7c, 0x5c, 0x55, 0x76, 0xbc, 0x50, 0x01, 0xaa, 0xfc, 0x80, 0x00, 0xcc, 0xbf, 0xa0, 
  0xd2, 0xcd, 0xbf, 0x6c, 0x41, 0x00, 0x7c, 0x5c, 0x55, 0x80, 0xbc, 0x50, 0x01, 0xaa, 0xfc, 0x80, 
  0x00, 0xcc, 0xbf, 0xa0, 0x86, 0x23, 0xff, 0x5c, 0x55, 0x00, 0x78, 0x5c, 0x01, 0xc6, 0x7f, 0x62, 
  0xe5, 0xcb, 0x97, 0xa4, 0x01, 0xce, 0x7f, 0x62, 0xe9, 0xd3, 0x97, 0xa4, 0xe4, 0xb3, 0xbf, 0xa0, 
  0xe8, 0xb3, 0xbf, 0x84, 0xd9, 0xb3, 0xbf, 0xa8, 0x1f, 0xb2, 0xff, 0x4c, 0xe8, 0xc9, 0x3f, 0xc3, 
  0xd9, 0xd3, 0x87, 0x38, 0xd9, 0xcb, 0x93, 0x38, 0xe8, 0xc9, 0x93, 0xa0, 0xe9, 0xcb, 0xbf, 0x80, 
  0x00, 0xca, 0x7f, 0xc1, 0x01, 0xc6, 0xf3, 0x68, 0x01, 0xc6, 0xcf, 0x64, 0xe5, 0xcb, 0xbf, 0xa8, 
  0xb0, 0x91, 0xff, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0x67, 0xb0, 0xbc, 0x50, 0x01, 0xce, 0xfc, 0x80, 
  0x00, 0xcc, 0xbf, 0xa0, 0x86, 0x23, 0xff, 0x5c, 0x67, 0x00, 0x70, 0x5c, 0xe7, 0xc7, 0xbf, 0x6c, 
  0xe8, 0xc9, 0xbf, 0x80, 0x00, 0xb2, 0xff, 0xa0, 0x20, 0xb4, 0xff, 0xa0, 0x01, 0xd2, 0xff, 0x29, 
  0xe5, 0xb3, 0xb3, 0x81, 0x01, 0xb2, 0xff, 0x31, 0x01, 0xd2, 0xff, 0x31, 0x60, 0xb4, 0xff, 0xe4, 
  0x03, 0xb2, 0xff, 0x2c, 0xd9, 0xcb, 0xbf, 0xa0, 0xb0, 0x91, 0xff, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 
  0x7a, 0xd4, 0xbc, 0x50, 0x01, 0xf4, 0xfc, 0x80, 0x00, 0xcc, 0xbf, 0xa0, 0x86, 0x23, 0xff, 0x5c, 
  0xcb, 0xc5, 0xbb, 0xa0, 0x7a, 0x00, 0x78, 0x5c, 0xe7, 0xc7, 0xbf, 0x6c, 0xe8, 0xc9, 0xbf, 0x84, 
  0x00, 0xb2, 0xff, 0xa0, 0x1e, 0xb4, 0xff, 0xa0, 0x01, 0xb2, 0xff, 0x2c, 0xe9, 0xcb, 0x3f, 0xc3, 
  0xe9, 0xcb, 0xaf, 0x84, 0x01, 0xb2, 0xef, 0x80, 0x01, 0xca, 0xff, 0x2c, 0x72, 0xb4, 0xff, 0xe4, 
  0xd9, 0xcb, 0xbf, 0xa0, 0xb0, 0x91, 0xff, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0xe2, 0xc7, 0xbf, 0xa0, 
  0x00, 0xc4, 0xff, 0xa0, 0xe3, 0xcb, 0xbf, 0xaa, 0x87, 0x00, 0x68, 0x5c, 0x1f, 0xc6, 0xff, 0x28, 
  0x1f, 0xc8, 0xff, 0xa0, 0x01, 0xca, 0xff, 0x2d, 0x01, 0xc8, 0xcf, 0x84, 0x81, 0x00, 0x4c, 0x5c, 
  0x01, 0xca, 0xff, 0x30, 0x02, 0xca, 0xff, 0x28, 0xb0, 0x91, 0xff, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 
  0x00, 0xb2, 0xff, 0xa0, 0x8b, 0x00, 0x7c, 0x5c, 0x01, 0xb2, 0xff, 0xa0, 0x92, 0x5f, 0xff, 0x5c, 
  0x98, 0x00, 0x70, 0x5c, 0x02, 0xca, 0xff, 0x2c, 0x00, 0xc4, 0xff, 0xa0, 0xe4, 0xc9, 0xbf, 0xa4, 
  0x1e, 0xc8, 0xff, 0x82, 0x20, 0xc8, 0x7f, 0xc1, 0x98, 0x00, 0x6c, 0x5c, 0xe4, 0xcb, 0xbf, 0x28, 
  0xd9, 0xcb, 0xbf, 0x80, 0x01, 0xca, 0xff, 0x28, 0x01, 0xc6, 0x7f, 0x62, 0xe5, 0xc5, 0xbf, 0x9c, 
  0x00, 0x00, 0x7c, 0x5c, 0x92, 0x5f, 0xff, 0x5c, 0x00, 0xc4, 0xcf, 0xa0, 0xb4, 0x00, 0x78, 0x5c, 
  0x01, 0xc6, 0x7f, 0x62, 0xcb, 0xc5, 0x97, 0xa0, 0xb4, 0x00, 0x54, 0x5c, 0x01, 0xc8, 0x7f, 0x62, 
  0x01, 0xca, 0xeb, 0x28, 0x01, 0xc8, 0xff, 0x38, 0xd1, 0xb3, 0xbf, 0xa0, 0x1f, 0xb4, 0xff, 0xa0, 
  0xd9, 0xc5, 0xbf, 0x68, 0x20, 0xb6, 0xff, 0xa0, 0x00, 0xb8, 0xff, 0xa0, 0xe2, 0xbb, 0xbf, 0xa0, 
  0x01, 0xba, 0xff, 0x29, 0xe2, 0xb9, 0xb3, 0x81, 0x01, 0xb8, 0xff, 0x31, 0x01, 0xba, 0xff, 0x31, 
  0xa9, 0xb6, 0xff, 0xe4, 0xdc, 0xcb, 0x3f, 0xc1, 0xd9, 0xc5, 0xb3, 0x6c, 0x01, 0xb2, 0xff, 0x28, 
  0xa4, 0xb4, 0xff, 0xe4, 0xe2, 0xcb, 0xbf, 0xa0, 0x01, 0xca, 0xff, 0x28, 0xb0, 0x91, 0xff, 0x5c, 
  0x00, 0x00, 0x7c, 0x5c, 0xca, 0x6e, 0xbd, 0x50, 0x01, 0x94, 0xfd, 0x80, 0x00, 0xcc, 0xbf, 0xa0, 
  0xe2, 0xb3, 0xbf, 0xa0, 0xe6, 0xb3, 0xbf, 0x6c, 0xd2, 0xb3, 0xbf, 0x62, 0xc2, 0x00, 0x68, 0x5c, 
  0xe2, 0xb3, 0xbf, 0xa0, 0xe6, 0xb3, 0xbf, 0x68, 0xd2, 0xb3, 0xbf, 0x67, 0xc7, 0x00, 0x68, 0x5c, 
  0xd2, 0xc5, 0x3f, 0x61, 0xc7, 0x00, 0x7c, 0x5c, 0xd2, 0xc5, 0x3f, 0x62, 0xc6, 0x00, 0x54, 0x5c, 
  0xe6, 0xc5, 0x3f, 0x87, 0xc7, 0x00, 0x7c, 0x5c, 0xe2, 0xcd, 0x3f, 0x87, 0x01, 0xc2, 0xff, 0xa0, 
  0xe1, 0xc3, 0xb3, 0xa4, 0x00, 0xc2, 0xeb, 0xa0, 0x00, 0x00, 0x7c, 0x5c, 0x3e, 0xaa, 0xfc, 0x5c, 
  0xdb, 0x0f, 0xc9, 0x3f, 0xe2, 0xbd, 0xbf, 0xa0, 0x68, 0xf4, 0xfc, 0x5c, 0xdb, 0x0f, 0xc9, 0x40, 
  0x88, 0x30, 0xfd, 0x5c, 0xcb, 0xc5, 0x3f, 0x86, 0xfc, 0x00, 0x68, 0x5c, 0x7b, 0x0e, 0xfd, 0x5c, 
  0x56, 0xce, 0xfc, 0x5c, 0xdb, 0x0f, 0xc9, 0x40, 0xe2, 0xcd, 0xbf, 0xa0, 0xde, 0xc5, 0xbf, 0xa0, 
  0x3c, 0xaa, 0xfc, 0x5c, 0xd2, 0xc5, 0x3f, 0x62, 0xdd, 0x00, 0x68, 0x5c, 0x3e, 0xaa, 0xfc, 0x5c, 
  0xdb, 0x0f, 0xc9, 0x40, 0x56, 0xce, 0xfc, 0x5c, 0x83, 0xf9, 0xa2, 0x44, 0xe2, 0xbb, 0xbf, 0xa0, 
  0x61, 0xd5, 0xfe, 0x5c, 0xe2, 0xb9, 0xbf, 0xa0, 0xdd, 0xc5, 0xbf, 0xa0, 0x88, 0x30, 0xfd, 0x5c, 
  0xd7, 0xc5, 0x3f, 0x61, 0xd8, 0xc5, 0x3f, 0x62, 0xe2, 0xc5, 0xbf, 0xb0, 0xd6, 0xc5, 0xbf, 0x68, 
  0x01, 0xc4, 0xff, 0x2c, 0xe2, 0xb5, 0xbf, 0x04, 0xda, 0xb5, 0xbf, 0xbc, 0x02, 0xc4, 0xcf, 0x80, 
  0x02, 0xc4, 0xf3, 0x84, 0xe2, 0xb7, 0xbf, 0x04, 0xdb, 0xb7, 0xbf, 0xbc, 0xda, 0xc5, 0xbf, 0xa0, 
  0x7b, 0x0e, 0xfd, 0x5c, 0xdc, 0xcd, 0xbf, 0xa2, 0xfa, 0x00, 0x68, 0x5c, 0xe2, 0xbb, 0xbf, 0xa0, 
  0xdb, 0xc5, 0xbf, 0xa0, 0xda, 0xc5, 0xbf, 0x84, 0x7b, 0x0e, 0xfd, 0x5c, 0x59, 0xce, 0xfc, 0x5c, 
  0xdd, 0xcd, 0xbf, 0xa0, 0x41, 0xaa, 0xfc, 0x5c, 0x68, 0xf4, 0xfc, 0x5c, 0x00, 0xff, 0x7f, 0x47, 
  0x00, 0x00, 0x7c, 0x5c, 0xe2, 0xbf, 0xbf, 0xa0, 0xcb, 0xf8, 0xfd, 0x5c, 0xe2, 0xc1, 0xbf, 0xa0, 
  0xdf, 0xc5, 0xbf, 0xa0, 0xcd, 0xf8, 0xfd, 0x5c, 0xe0, 0xcd, 0xbf, 0xa0, 0x6b, 0xf4, 0xfc, 0x5c, 
  0x00, 0x00, 0x7c, 0x5c, 0x0d, 0x3f, 0xfe, 0x5c, 0x68, 0xf4, 0xfc, 0x5c, 0x3b, 0xaa, 0xb8, 0x3f, 
  0x00, 0x00, 0x7c, 0x5c, 0x0d, 0x3f, 0xfe, 0x5c, 0x68, 0xf4, 0xfc, 0x5c, 0x78, 0x9a, 0x54, 0x40, 
  0x00, 0x00, 0x7c, 0x5c, 0x92, 0x5f, 0xff, 0x5c, 0x1e, 0x01, 0x78, 0x5c, 0x01, 0xc6, 0x7f, 0x62, 
  0x1e, 0x01, 0x54, 0x5c, 0xe4, 0xbb, 0xbf, 0xa0, 0xe5, 0xb3, 0xbf, 0xa0, 0x11, 0xb2, 0xff, 0x28, 
  0xd5, 0xb3, 0xbf, 0x60, 0xd3, 0xb3, 0xbf, 0x80, 0x7e, 0x0b, 0xff, 0x5c, 0xe2, 0xb5, 0xbf, 0xa0, 
  0x6b, 0xfb, 0xfe, 0x5c, 0xe2, 0xcd, 0xbf, 0xa0, 0xdd, 0xc5, 0xbf, 0xa0, 0x7b, 0x0e, 0xfd, 0x5c, 
  0x41, 0xaa, 0xfc, 0x5c, 0x1f, 0x01, 0x7c, 0x5c, 0xcb, 0xc5, 0xbf, 0xa0, 0x00, 0x00, 0x7c, 0x5c, 
  0x56, 0xce, 0xfc, 0x5c, 0x3b, 0xaa, 0xb8, 0x3f, 0x25, 0x01, 0x7c, 0x5c, 0x56, 0xce, 0xfc, 0x5c, 
  0x78, 0x9a, 0x54, 0x40, 0x92, 0x5f, 0xff, 0x5c, 0x42, 0x01, 0x70, 0x5c, 0xca, 0xc5, 0xab, 0xa0, 
  0x42, 0x01, 0x68, 0x5c, 0xe2, 0xbb, 0xbf, 0xa0, 0x88, 0x30, 0xfd, 0x5c, 0xe2, 0xb9, 0xbf, 0xa8, 
  0xdd, 0xc5, 0xbf, 0xa0, 0x61, 0xd5, 0xfe, 0x5c, 0x92, 0x5f, 0xff, 0x5c, 0xe4, 0xc9, 0xbf, 0xa4, 
  0xe4, 0xcb, 0xbf, 0x28, 0xe5, 0xb3, 0xbf, 0xa0, 0x11, 0xb2, 0xff, 0x28, 0xd5, 0xb3, 0xbf, 0x60, 
  0xd4, 0xb3, 0xbf, 0x80, 0x7e, 0x0b, 0xff, 0x5c, 0xe2, 0xb5, 0xbf, 0xa0, 0x6b, 0xfb, 0xfe, 0x5c, 
  0x3e, 0xaa, 0xfc, 0x5c, 0x00, 0x00, 0x80, 0x3f, 0x92, 0x5f, 0xff, 0x5c, 0xdc, 0xc9, 0xbf, 0x80, 
  0xb0, 0x91, 0xff, 0x5c, 0xd2, 0xbb, 0x3f, 0x62, 0x42, 0x01, 0x68, 0x5c, 0xe2, 0xcd, 0xbf, 0xa0, 
  0xca, 0xc5, 0xbf, 0xa0, 0x6b, 0xf4, 0xfc, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0xcb, 0xcd, 0x3f, 0x62, 
  0xca, 0xc5, 0xab, 0xa0, 0xe2, 0xbf, 0xbf, 0xa1, 0x55, 0x01, 0x4c, 0x5c, 0xe6, 0xc5, 0xbf, 0xa0, 
  0x92, 0x5f, 0xff, 0x5c, 0xdf, 0xc5, 0xbf, 0xa0, 0x53, 0x01, 0x68, 0x5c, 0xd2, 0xc9, 0x3f, 0x62, 
  0x51, 0x01, 0x54, 0x5c, 0x17, 0xc8, 0xff, 0x4c, 0xe4, 0xcb, 0xbf, 0x2c, 0xce, 0xcb, 0x3f, 0x62, 
  0x53, 0x01, 0x68, 0x5c, 0xcb, 0xc5, 0xbf, 0xa0, 0x60, 0x01, 0x7c, 0x5c, 0xd0, 0xcb, 0x3f, 0x62, 
  0xd2, 0xbf, 0xab, 0x64, 0xd2, 0xcd, 0x3f, 0x61, 0xd2, 0xc5, 0xbf, 0x66, 0x51, 0x01, 0x60, 0x5c, 
  0x60, 0x01, 0x68, 0x5c, 0xe6, 0xbd, 0xbf, 0xa0, 0x0d, 0x3f, 0xfe, 0x5c, 0xde, 0xcd, 0xbf, 0xa0, 
  0x59, 0xce, 0xfc, 0x5c, 0x25, 0x85, 0xfe, 0x5c, 0xd2, 0xbf, 0x3f, 0x62, 0xd2, 0xc5, 0x97, 0x6c, 
  0x00, 0x00, 0x7c, 0x5c, 0x92, 0x5f, 0xff, 0x5c, 0xd2, 0xc9, 0x3f, 0x62, 0x68, 0x01, 0x74, 0x5c, 
  0x17, 0xc8, 0xff, 0x4c, 0xe4, 0xcb, 0xbf, 0x2c, 0xce, 0xcb, 0xbf, 0x60, 0x00, 0xc8, 0xff, 0xa0, 
  0xb0, 0x91, 0xff, 0x5c, 0xd2, 0xc5, 0xbf, 0x64, 0x00, 0x00, 0x7c, 0x5c, 0xd9, 0xb7, 0xbf, 0x04, 
  0x00, 0xb4, 0x7f, 0x86, 0x00, 0xb2, 0xeb, 0xa0, 0x74, 0x01, 0x68, 0x5c, 0x02, 0xb2, 0xff, 0x80, 
  0xd5, 0xb3, 0x3f, 0x62, 0xcf, 0xb3, 0xab, 0xa0, 0xd9, 0xb3, 0x97, 0x04, 0xdb, 0xb3, 0xbf, 0x84, 
  0xdb, 0xcb, 0xbf, 0xa0, 0x80, 0x0b, 0xff, 0x5c, 0xe2, 0xb7, 0xbf, 0xa0, 0xd9, 0xcb, 0xbf, 0xa0, 
  0x80, 0x0b, 0xff, 0x5c, 0xda, 0xcd, 0xbf, 0xa0, 0x59, 0xce, 0xfc, 0x5c, 0xdb, 0xcd, 0xbf, 0xa0, 
  0x41, 0xaa, 0xfc, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0x0e, 0xca, 0xff, 0x2c, 0x81, 0x01, 0x7c, 0x5c, 
  0x10, 0xca, 0xff, 0x2c, 0x03, 0xca, 0xff, 0x28, 0x00, 0xc6, 0xff, 0xa0, 0x00, 0xc8, 0xff, 0xa0, 
  0xb0, 0x91, 0xff, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0xe2, 0xb3, 0xbf, 0xa0, 0xe6, 0xc5, 0xbf, 0xa0, 
  0x92, 0x5f, 0xff, 0x5c, 0x91, 0x01, 0x70, 0x5c, 0xe2, 0xcd, 0xbf, 0xa0, 0xe3, 0xcf, 0xbf, 0xa0, 
  0xe4, 0xd1, 0xbf, 0xa0, 0xe5, 0xd3, 0xbf, 0xa0, 0xd9, 0xc5, 0xbf, 0xa0, 0x92, 0x5f, 0xff, 0x5c, 
  0x00, 0xd2, 0x7f, 0x86, 0x00, 0x00, 0x7c, 0x5c, 0xe2, 0xc7, 0xbf, 0xa0, 0x1f, 0xc6, 0xff, 0x28, 
  0xe2, 0xcb, 0xbf, 0xa0, 0xcd, 0xcb, 0xbf, 0x60, 0xe2, 0xc9, 0xbf, 0xa0, 0x01, 0xc8, 0xff, 0x2c, 
  0x18, 0xc8, 0xff, 0x2a, 0x9f, 0x01, 0x68, 0x5c, 0xff, 0xc8, 0x7f, 0x86, 0xaa, 0x01, 0x54, 0x5c, 
  0xcb, 0xc5, 0xbf, 0xa0, 0x08, 0xc6, 0xff, 0xa0, 0xad, 0x01, 0x7c, 0x5c, 0xe4, 0xcb, 0x3f, 0x6a, 
  0xa4, 0x01, 0x54, 0x5c, 0x02, 0xc6, 0xff, 0x68, 0x96, 0xc8, 0xff, 0xa4, 0xad, 0x01, 0x7c, 0x5c, 
  0x07, 0xca, 0xff, 0x2c, 0xd0, 0xcb, 0x3f, 0x62, 0xac, 0x01, 0x54, 0x5c, 0x01, 0xca, 0xff, 0x2c, 
  0x01, 0xc8, 0xff, 0x84, 0xa5, 0x01, 0x7c, 0x5c, 0x06, 0xca, 0xff, 0x2c, 0xd0, 0xcb, 0xbf, 0x68, 
  0x7f, 0xc8, 0xff, 0x84, 0x08, 0xc6, 0x7f, 0x61, 0x00, 0xca, 0x7f, 0x86, 0x00, 0x00, 0x7c, 0x5c, 
  0x00, 0xca, 0x7f, 0x86, 0x00, 0xc8, 0xeb, 0xa0, 0xc3, 0x01, 0x68, 0x5c, 0x01, 0xca, 0xff, 0x2d, 
  0x01, 0xc8, 0xcf, 0x84, 0xb3, 0x01, 0x4c, 0x5c, 0x02, 0xc8, 0xff, 0x80, 0x00, 0xcb, 0xff, 0x81, 
  0x01, 0xc8, 0xf3, 0x80, 0x7f, 0xc8, 0xff, 0x80, 0xcc, 0xc9, 0xbf, 0x40, 0xff, 0xc8, 0xff, 0x44, 
  0x01, 0xc8, 0x7f, 0xc1, 0xc3, 0x01, 0x4c, 0x5c, 0x01, 0xca, 0xff, 0x68, 0x01, 0xca, 0xff, 0x20, 
  0xe4, 0xc9, 0xbf, 0xa4, 0xe4, 0xcb, 0xbf, 0x28, 0x00, 0xc8, 0xff, 0xa0, 0xe5, 0xc5, 0xbf, 0xa0, 
  0x09, 0xc4, 0xff, 0x28, 0xe4, 0xc5, 0xbf, 0x58, 0x1f, 0xc6, 0xff, 0x2c, 0xe3, 0xc5, 0xbf, 0x68, 
  0x00, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x3f, 0xff, 0xff, 0xff, 0x7f, 
  0xe9, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x00, 0xff, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x01, 0x00, 
  0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x80, 0x00, 0xc0, 0x00, 0x00, 
  0x00, 0xd0, 0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 
  0x00, 0x10, 0x00, 0x00, 
};
int32_t Float32_start(Float32 *self)
{
  int32_t okay = 0;
  /* Start start floating point engine in a new cog.
    Returns:     True (non-zero) if cog started, or False (0) if no cog is available.
   */
  Float32_stop(self);
  okay = self->cog = cognew((int32_t)(((int32_t *)&dat[0])), (int32_t)(&self->command)) + 1;
  return okay;
}

void Float32_stop(Float32 *self)
{
  int32_t 	_tmp__0021;
  /* Stop floating point engine and release the cog. */
  if (self->cog) {
    cogstop(( ( (_tmp__0021 = self->cog), (self->cog = 0) ), _tmp__0021 ) - 1);
  }
  self->command = 0;
}

int32_t Float32_FAdd(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0022[2];
  _parm__0022[0] = a;
  _parm__0022[1] = b;
  /* Addition: result = a + b
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FADDCMD + ((int32_t)(&_parm__0022[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FSub(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0023[2];
  _parm__0023[0] = a;
  _parm__0023[1] = b;
  /* Subtraction: result = a - b
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FSUBCMD + ((int32_t)(&_parm__0023[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FMul(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0024[2];
  _parm__0024[0] = a;
  _parm__0024[1] = b;
  /* Multiplication: result = a * b
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FMULCMD + ((int32_t)(&_parm__0024[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FDiv(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0025[2];
  _parm__0025[0] = a;
  _parm__0025[1] = b;
  /* Division: result = a / b
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FDIVCMD + ((int32_t)(&_parm__0025[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FFloat(Float32 *self, int32_t n)
{
  int32_t _parm__0026[1];
  _parm__0026[0] = n;
  /* Convert integer to floating point.
    Parameters:
      n        32-bit integer value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FFLOATCMD + ((int32_t)(&_parm__0026[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FTrunc(Float32 *self, int32_t a)
{
  int32_t _parm__0027[1];
  _parm__0027[0] = a;
  /* Convert floating point to integer (with truncation).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit integer value 
   */
  self->command = FLOAT32_FTRUNCCMD + ((int32_t)(&_parm__0027[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FRound(Float32 *self, int32_t a)
{
  int32_t _parm__0028[1];
  _parm__0028[0] = a;
  /* Convert floating point to integer (with rounding).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit integer value 
   */
  self->command = FLOAT32_FROUNDCMD + ((int32_t)(&_parm__0028[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FSqr(Float32 *self, int32_t a)
{
  int32_t _parm__0029[1];
  _parm__0029[0] = a;
  /* Square root.
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value 
   */
  self->command = FLOAT32_FSQRCMD + ((int32_t)(&_parm__0029[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FCmp(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0030[2];
  _parm__0030[0] = a;
  _parm__0030[1] = b;
  /* Floating point comparison.
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value
    Returns:   32-bit integer value
               -1 if a < b
                0 if a == b
                1 if a > b
   */
  self->command = FLOAT32_FCMPCMD + ((int32_t)(&_parm__0030[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Sin(Float32 *self, int32_t a)
{
  int32_t _parm__0031[1];
  _parm__0031[0] = a;
  /* Sine of an angle. 
    Parameters:
      a        32-bit floating point value (angle in radians)
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_SINCMD + ((int32_t)(&_parm__0031[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Cos(Float32 *self, int32_t a)
{
  int32_t _parm__0032[1];
  _parm__0032[0] = a;
  /* Cosine of an angle.
    Parameters:
      a        32-bit floating point value (angle in radians)
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_COSCMD + ((int32_t)(&_parm__0032[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Tan(Float32 *self, int32_t a)
{
  int32_t _parm__0033[1];
  _parm__0033[0] = a;
  /* Tangent of an angle.
    Parameters:
      a        32-bit floating point value (angle in radians)
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_TANCMD + ((int32_t)(&_parm__0033[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Log(Float32 *self, int32_t a)
{
  int32_t _parm__0034[1];
  _parm__0034[0] = a;
  /* Logarithm (base e).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_LOGCMD + ((int32_t)(&_parm__0034[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Log10(Float32 *self, int32_t a)
{
  int32_t _parm__0035[1];
  _parm__0035[0] = a;
  /* Logarithm (base 10).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_LOG10CMD + ((int32_t)(&_parm__0035[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Exp(Float32 *self, int32_t a)
{
  int32_t _parm__0036[1];
  _parm__0036[0] = a;
  /* Exponential (e raised to the power a).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_EXPCMD + ((int32_t)(&_parm__0036[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Exp10(Float32 *self, int32_t a)
{
  int32_t _parm__0037[1];
  _parm__0037[0] = a;
  /* Exponential (10 raised to the power a).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_EXP10CMD + ((int32_t)(&_parm__0037[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Pow(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0038[2];
  _parm__0038[0] = a;
  _parm__0038[1] = b;
  /* Power (a to the power b).
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value  
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_POWCMD + ((int32_t)(&_parm__0038[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Frac(Float32 *self, int32_t a)
{
  int32_t _parm__0039[1];
  _parm__0039[0] = a;
  /* Fraction (returns fractional part of a).
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FRACCMD + ((int32_t)(&_parm__0039[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FNeg(int32_t a)
{
  /* Negate: result = -a.
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  return (a ^ 0x80000000);
}

int32_t Float32_FAbs(int32_t a)
{
  /* Absolute Value: result = |a|.
    Parameters:
      a        32-bit floating point value
    Returns:   32-bit floating point value
   */
  return (a & 0x7fffffff);
}

int32_t Float32_Radians(Float32 *self, int32_t a)
{
  int32_t _local__0040[2];
  /* Convert to radians
    Parameters:
      a        32-bit floating point value (angle in degrees)
    Returns:   32-bit floating point value (angle in radians)
   */
  _local__0040[0] = a;
  _local__0040[1] = 0x3c8efa35;
  // sendCmd(FMulCmd + @a) 
  self->command = FLOAT32_FMULCMD + ((int32_t)(&_local__0040[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_Degrees(Float32 *self, int32_t a)
{
  int32_t _local__0041[2];
  /* Convert to degrees
    Parameters:
      a        32-bit floating point value (angle in radians)
    Returns:   32-bit floating point value (angle in degrees)
   */
  _local__0041[0] = a;
  _local__0041[1] = 0x42652ee0;
  // sendCmd(FMulCmd + @a) 
  self->command = FLOAT32_FMULCMD + ((int32_t)(&_local__0041[0]));
  while (self->command) {
    Yield__();
  }
  return self->cmdReturn;
}

int32_t Float32_FMin(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0042[2];
  _parm__0042[0] = a;
  _parm__0042[1] = b;
  /* Minimum: result = the minimum value a or b.
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value  
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FCMPCMD + ((int32_t)(&_parm__0042[0]));
  while (self->command) {
    Yield__();
  }
  if (self->cmdReturn < 0) {
    return _parm__0042[0];
  }
  return _parm__0042[1];
}

int32_t Float32_FMax(Float32 *self, int32_t a, int32_t b)
{
  int32_t _parm__0043[2];
  _parm__0043[0] = a;
  _parm__0043[1] = b;
  /* Maximum: result = the maximum value a or b.
    Parameters:
      a        32-bit floating point value
      b        32-bit floating point value  
    Returns:   32-bit floating point value
   */
  self->command = FLOAT32_FCMPCMD + ((int32_t)(&_parm__0043[0]));
  while (self->command) {
    Yield__();
  }
  if (self->cmdReturn < 0) {
    return _parm__0043[1];
  }
  return _parm__0043[0];
}

/* 
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */
