//
// automatically generated by spin2cpp v3.5.0 on Sat Feb 25 23:15:46 2017
// spin2cpp --ccode --main /Users/altergator/Downloads/Freq_Counter_Demo - Archive  [Date 2017.02.25  Time 20/Freq_Counter_Demo.spin 
//

// *****************************************
// *  Frequency Counter Tuner v1.0         *
// *  Author: Ken Gracey with all original *
// *  work by Pete Hemery                  *
// *  See end of file for terms of use.    *
// *  Modified from Microphone-to-VGA v1.0 *
// *  By Chip Gracey                       *
// *****************************************
// This program uses the Propeller FLIP Module
//
// The microphone is digitized and the number of samples between zero crossings is counted.
// This is then sent to the spin cog for averaging and if a note is detected, information
// is displayed on Parallax Serial Terminal. 
//
// -----------------------
// Modified Mic-VGA demo for Undergraduate Project 2011-2012
// VGA Displays detected frequency, note, octave and cent offset from microphone input.
#include <propeller.h>
#include "Freq_Counter_Demo.h"

#ifdef __GNUC__
#define INLINE__ static inline
#else
#define INLINE__ static
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static  void Freq_Counter_Demo_note_worthy(Freq_Counter_Demo *self, int32_t freq);

static char dat[] = {
  0x42, 0x20, 0x43, 0x20, 0x43, 0x23, 0x44, 0x20, 0x45, 0x62, 0x45, 0x20, 0x46, 0x20, 0x46, 0x23, 
  0x47, 0x20, 0x41, 0x62, 0x41, 0x20, 0x42, 0x62, 0xf0, 0xc9, 0xbc, 0xa0, 0x64, 0xca, 0xbc, 0xa0, 
  0x04, 0xca, 0xfc, 0x80, 0x64, 0xc4, 0xbc, 0xa0, 0x08, 0xc4, 0xfc, 0x84, 0x64, 0xc6, 0xbc, 0xa0, 
  0x04, 0xc6, 0xfc, 0x84, 0x52, 0xec, 0xbf, 0xa0, 0x08, 0xf0, 0xff, 0x50, 0x09, 0xf0, 0xff, 0x54, 
  0x48, 0xf0, 0xff, 0x58, 0x01, 0xf4, 0xff, 0xa0, 0x00, 0xb6, 0xfc, 0xa0, 0xf1, 0xd7, 0xbc, 0xa0, 
  0x51, 0xd6, 0xbc, 0x80, 0x51, 0xd6, 0xbc, 0xf8, 0xfc, 0xdb, 0xbc, 0xa0, 0x6c, 0xda, 0xbc, 0x84, 
  0x6d, 0xd8, 0xbc, 0x80, 0x63, 0xda, 0x3c, 0x08, 0x01, 0xcc, 0xfc, 0xa0, 0x62, 0xcc, 0x3c, 0x08, 
  0x62, 0xcc, 0xbc, 0x08, 0x16, 0xcc, 0x7c, 0xe8, 0x63, 0xda, 0xbc, 0x04, 0x6d, 0xd4, 0xbc, 0x80, 
  0x26, 0xaa, 0xfc, 0xe4, 0x5a, 0xaa, 0xbc, 0xa0, 0x0a, 0xd4, 0xfc, 0x28, 0x6a, 0xce, 0xbc, 0xa0, 
  0x00, 0xd4, 0xfc, 0xa0, 0x00, 0xbe, 0x7c, 0x86, 0x01, 0xbe, 0xd4, 0x84, 0x26, 0x00, 0x54, 0x5c, 
  0x67, 0xc0, 0xbc, 0xa0, 0x5e, 0xc0, 0xbc, 0x84, 0x67, 0xc2, 0xbc, 0xa0, 0x5e, 0xc2, 0xbc, 0x80, 
  0x6d, 0xdc, 0xbc, 0x4c, 0x6d, 0xde, 0xbc, 0x48, 0x33, 0xac, 0xfc, 0xe4, 0x57, 0xac, 0xbc, 0xa0, 
  0x6f, 0xcc, 0xbc, 0xa0, 0x6e, 0xcc, 0xbc, 0x84, 0x03, 0xcc, 0xfc, 0x28, 0x6e, 0xd0, 0xbc, 0xa0, 
  0x66, 0xd0, 0xbc, 0x80, 0x6f, 0xd2, 0xbc, 0xa0, 0x66, 0xd2, 0xbc, 0x84, 0x59, 0xdc, 0xbc, 0xa0, 
  0x00, 0xde, 0xfc, 0xa0, 0x0f, 0xbe, 0x7c, 0xe8, 0x69, 0xcc, 0xbc, 0xa0, 0x68, 0xcc, 0xbc, 0x84, 
  0x16, 0xcc, 0x7c, 0x85, 0x00, 0xb6, 0x7c, 0x86, 0x00, 0xb6, 0xf0, 0xa0, 0x01, 0xb6, 0xcc, 0xa0, 
  0x00, 0xba, 0xd0, 0xa0, 0x00, 0xcc, 0xd0, 0xa0, 0x64, 0xcc, 0x10, 0x08, 0x00, 0xb6, 0x7c, 0x86, 
  0x00, 0xba, 0xe8, 0xa0, 0x0f, 0x00, 0x68, 0x5c, 0x01, 0xba, 0xfc, 0x80, 0x01, 0xb8, 0x7c, 0x86, 
  0x60, 0xda, 0x28, 0x85, 0x02, 0xb8, 0xe0, 0xa0, 0x4a, 0x00, 0x60, 0x5c, 0x02, 0xb8, 0x7c, 0x86, 
  0x61, 0xda, 0x28, 0x85, 0x01, 0xb8, 0xc8, 0xa0, 0x4a, 0x00, 0x48, 0x5c, 0x0f, 0x00, 0x7c, 0x5c, 
  0x00, 0xba, 0x7c, 0x86, 0x0f, 0x00, 0x68, 0x5c, 0x65, 0xba, 0x3c, 0x08, 0x00, 0xba, 0xfc, 0xa0, 
  0x64, 0xb8, 0x3c, 0x08, 0x00, 0xcc, 0xfc, 0xa2, 0x0f, 0x00, 0x7c, 0x5c, 0xa3, 0x2c, 0x00, 0x00, 
  0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 
  0x01, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 
  0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x0b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 
};
void Freq_Counter_Demo_start(Freq_Counter_Demo *self)
{
  int32_t 	f, i, iten, ihun, freq, time, samples, screen_timeout;
  ((int32_t *)(&self->flag))[0] = 0;
  // start floating point engine
  Float32_start(&self->f32);
  // start filter impulse response engine
  fir_filter_7k_start(&self->fir, (&self->fir_busy));
  if (((INA >> 31) & 0x1) == 1) {
    // Check if we're connected via USB
    self->pst_on = 1;
    // start serial com
    Parallax_serial_terminal_Start(&self->pst, 115200);
    Parallax_serial_terminal_Clear(&self->pst);
  } else {
    self->pst_on = 0;
  }
  f = cognew((int32_t)(((int32_t *)&dat[24])), (int32_t)(&self->flag));
  if (self->pst_on) {
    Parallax_serial_terminal_Str(&self->pst, (char *)"Sampler Cog: ");
    Parallax_serial_terminal_Dec(&self->pst, f);
    Parallax_serial_terminal_NewLine(&self->pst);
    Parallax_serial_terminal_Str(&self->pst, (char *)"Sample Rate: ");
    Parallax_serial_terminal_Dec(&self->pst, FREQ_COUNTER_DEMO_SAMPLE_RATE);
    Parallax_serial_terminal_NewLine(&self->pst);
  }
  time = Float32_FDiv(&self->f32, Float32_FFloat(&self->f32, 1), Float32_FDiv(&self->f32, Float32_FFloat(&self->f32, FREQ_COUNTER_DEMO_CLK_FREQ), Float32_FFloat(&self->f32, FREQ_COUNTER_DEMO_SAMPLE_RATE)));
  if (self->pst_on) {
    // to ms for display
    time = Float32_FMul(&self->f32, time, Float32_FFloat(&self->f32, 1000));
    Parallax_serial_terminal_Str(&self->pst, (char *)"Time Taken per Sample: ");
    Parallax_serial_terminal_Dec(&self->pst, Float32_FTrunc(&self->f32, time));
    Parallax_serial_terminal_Str(&self->pst, (char *)".");
    Parallax_serial_terminal_Dec(&self->pst, Float32_FTrunc(&self->f32, Float32_FMul(&self->f32, time, Float32_FFloat(&self->f32, 10))) % 10);
    Parallax_serial_terminal_Dec(&self->pst, Float32_FTrunc(&self->f32, Float32_FMul(&self->f32, time, Float32_FFloat(&self->f32, 100))) % 10);
    Parallax_serial_terminal_Dec(&self->pst, Float32_FTrunc(&self->f32, Float32_FMul(&self->f32, time, Float32_FFloat(&self->f32, 1000))) % 10);
    Parallax_serial_terminal_Str(&self->pst, (char *)" ms\r");
    // to secs for Hz conversion
    time = Float32_FDiv(&self->f32, time, Float32_FFloat(&self->f32, 1000));
  }
  f = i = iten = ihun = 0;
  screen_timeout = FREQ_COUNTER_DEMO_TIMEOUT;
  while (1) {
    while (((int32_t *)(&self->flag))[0] == f) {
      // while waiting for a new value, countdown to reset display variables
      if (screen_timeout != 0) {
        screen_timeout = screen_timeout - 1;
      }
      if (screen_timeout == 1) {
      }
    }
    // f is the local copy of the flag register
    f = ((int32_t *)(&self->flag))[0];
    if (f == 0) {
      i = iten = ihun = 0;
      //      pst.str(string("STOPPED COUNTING",pst#NL))
      continue;
    }
    samples = ((int32_t *)(&self->sample_cnt))[0];
    /* 
        pst.str(string("Sample Count: "))
        pst.dec(samples)
        pst.newline
     */
    self->sample_ones[i] = samples;
    i = i + 1;
    // i used to keep track of incoming samples 1-10 (well, 0-9)
    // once 10 is reached, i is used as for loop variable, then reset to 0
    if (i == 10) {
      samples = 0;
      for(i = 0; i <= 9; i++) {
        // sum last 10 values of sample_count for averaging
        samples = samples + self->sample_ones[i];
      }
      self->sample_tens[iten] = samples;
      iten = iten + 1;
      if (iten == 10) {
        samples = 0;
        iten = 0;
        for(i = 0; i <= 9; i++) {
          // sum last 100 samples
          samples = samples + self->sample_tens[i];
        }
        self->sample_huns[ihun] = samples;
        ihun = ihun + 1;
        // since there are 2 zero crossings per wave, divide by 50 instead of 100
        // frequency = 1 / (number of waves * time taken)
        freq = Float32_FDiv(&self->f32, Float32_FFloat(&self->f32, 1), Float32_FMul(&self->f32, Float32_FDiv(&self->f32, Float32_FFloat(&self->f32, samples), Float32_FFloat(&self->f32, 50)), time));
        // frequency can vary wildly before settling down, so check against previous value
        if (self->prev_freq == Float32_FRound(&self->f32, freq)) {
          screen_timeout = FREQ_COUNTER_DEMO_TIMEOUT;
          Freq_Counter_Demo_note_worthy(self, freq);
        } else {
          // if new value isn't the same as previous, countdown to reset display variables
          if (screen_timeout != 0) {
            screen_timeout = screen_timeout - 1;
          }
          if (screen_timeout == 1) {
          }
        }
        //    gui.reset_display
        // save the current freq for comparison next iteration
        self->prev_freq = Float32_FRound(&self->f32, freq);
        if (ihun == 10) {
          ihun = 0;
        }
      }
      i = 0;
    }
  }
}

static void Freq_Counter_Demo_note_worthy(Freq_Counter_Demo *self, int32_t freq)
{
  int32_t 	i, j, lnote, oct, cents, note, char1, char2;
  /* 
             n / 12
    f = (2 ^        ) x 440 Hz
  
    note = (log2(f / 440)) x 12
  
    This uses A4 as the centre octave of 0. So offset by 4.
  
    octaves automatically yield factors of two times the original frequency,
     since n is therefore a multiple of 12
     (12k, where k is the number of octaves up or down), and so the formula reduces to:
  
             12k / 12                    k
    f = (2 ^          ) x 440   =   (2 ^   ) x 440
  
    code:
    lnote = log2(f / 440)
    lnote = log(f / 440) / log(2)
  
    octave = lnote + 4  'WAS 4
  
    note = ( octave - truncated (octave) ) * 12
  
    cents = (note - truncated (note) ) * 100
   */
  if (self->pst_on) {
    Parallax_serial_terminal_Str(&self->pst, (char *)"Freq: ");
    Parallax_serial_terminal_Dec(&self->pst, Float32_FTrunc(&self->f32, freq));
    Parallax_serial_terminal_Char(&self->pst, '.');
    Parallax_serial_terminal_Dec(&self->pst, Float32_FRound(&self->f32, Float32_FMul(&self->f32, freq, Float32_FFloat(&self->f32, 100))) % 100);
    Parallax_serial_terminal_Str(&self->pst, (char *)"Hz\r");
  }
  // lnote = log(f / 440) / log(2)
  lnote = Float32_FDiv(&self->f32, Float32_Log(&self->f32, Float32_FDiv(&self->f32, freq, Float32_FFloat(&self->f32, 440))), Float32_Log(&self->f32, Float32_FFloat(&self->f32, 2)));
  // octave = lnote + 4
  oct = Float32_FAdd(&self->f32, lnote, Float32_FFloat(&self->f32, 4));
  /* 
    pst.str(string("Octave: "))
    pst.dec(F32.FTrunc(oct))
    pst.char(" ")
   */
  // note = ( octave - trunc(octave) ) * 12
  note = Float32_FMul(&self->f32, Float32_FSub(&self->f32, oct, Float32_FFloat(&self->f32, Float32_FTrunc(&self->f32, oct))), Float32_FFloat(&self->f32, 12));
  // cents = ( note - trunc(note) ) * 100
  cents = Float32_FRound(&self->f32, Float32_FMul(&self->f32, Float32_FSub(&self->f32, note, Float32_FFloat(&self->f32, Float32_FTrunc(&self->f32, note))), Float32_FFloat(&self->f32, 100)));
  /* 
    pst.str(string("Cents: "))
    pst.dec(cents)
    pst.char(" ")
    pst.newline
   */
  oct = Float32_FTrunc(&self->f32, oct);
  note = Float32_FRound(&self->f32, note);
  if (cents == 100) {
    cents = 0;
  }
  if (cents > 50) {
    cents = cents - 100;
  }
  if (note > 2) {
    // Octaves increment on the letter C
    oct = oct + 1;
  }
  if (note > 11) {
    // catch a roll over
    note = 0;
  }
  if (self->pst_on) {
    Parallax_serial_terminal_Str(&self->pst, (char *)"Note: ");
    Parallax_serial_terminal_Dec(&self->pst, oct);
    Parallax_serial_terminal_Char(&self->pst, ' ');
  }
  // fetch relevant character from table below
  char1 = ((char *)&dat[0])[(note * 2)];
  char2 = ((char *)&dat[0])[((note * 2) + 1)];
  if (self->pst_on) {
    Parallax_serial_terminal_Char(&self->pst, char1);
    Parallax_serial_terminal_Char(&self->pst, char2);
    Parallax_serial_terminal_NewLine(&self->pst);
    Parallax_serial_terminal_Str(&self->pst, (char *)"Cents: ");
    Parallax_serial_terminal_Dec(&self->pst, cents);
    Parallax_serial_terminal_Char(&self->pst, ' ');
    Parallax_serial_terminal_NewLine(&self->pst);
    Parallax_serial_terminal_NewLine(&self->pst);
  }
  // update routine takes int freq value scaled up by 100
  freq = Float32_FRound(&self->f32, Float32_FMul(&self->f32, freq, Float32_FFloat(&self->f32, 100)));
}

/* 
â”Œâ”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”
â”‚                                                   TERMS OF USE: MIT License                                                  â”‚                                                            
â”œâ”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”¤
â”‚Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    â”‚ 
â”‚files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    â”‚
â”‚modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Softwareâ”‚
â”‚is furnished to do so, subject to the following conditions:                                                                   â”‚
â”‚                                                                                                                              â”‚
â”‚The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.â”‚
â”‚                                                                                                                              â”‚
â”‚THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          â”‚
â”‚WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         â”‚
â”‚COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   â”‚
â”‚ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         â”‚
â””â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”˜
 */
__asm__( "    .global __clkfreqval\n" );
__asm__( "    __clkfreqval = 0x4c4b400\n" );
__asm__( "    .global __clkmodeval\n" );
__asm__( "    __clkmodeval = 0x6f\n" );

Freq_Counter_Demo MainObj__;

int main() {
  Freq_Counter_Demo_start(&MainObj__);
  return 0;
}
